<?php

defined('_JEXEC') or die;

if (!defined('_DESIGNER_FUNCTIONS')) {

    define('_DESIGNER_FUNCTIONS', 1);

    $application = JApplication::getInstance('site');
    $template = $application->getTemplate();
    $templatePath = JPATH_SITE . '/templates/' . $template;
    if (false !== strpos(__FILE__, 'editor'))
        $templatePath .= '/editor';

    $GLOBALS['designer_settings'] = array(
        'currentTemplate' => 'default.php',
        'data' => '',
        'block' => array('has_header' => true),
        'vmenu' => array('show_submenus' => true, 'simple' => false),
        'active_paginator' => 'common',
        'is_preview' => true,
        'current_theme_path' => $templatePath,
        'category_layout_type' => isset($_COOKIE['layoutType']) ? $_COOKIE['layoutType'] : 'grid',
        'category_layout_count' => 0
    );

    require_once dirname(__FILE__) . '/library/Designer.php';
    
    function renderTemplateFromIncludes($name, $args = array(), $folder = 'includes') 
    {
        $filePath = $GLOBALS['designer_settings']['current_theme_path'] .
            '/' . $folder . '/' . $name . '.php';
        include_once($filePath);
        return call_user_func_array($name, $args);
    }
    
    function funcUrlToHref($url)
    {
        $result = '';
        $p = parse_url($url);
        if (isset($p['scheme']) && isset($p['host'])) {
            $result = $p['scheme'] . '://';
            if (isset($p['user'])) {
                $result .= $p['user'];
                if (isset($p['pass']))
                    $result .= ':' . $p['pass'];
                $result .= '@@';
            }
            $result .= $p['host'];
            if (isset($p['port']))
                $result .= ':' . $p['port'];
            if (!isset($p['path']))
                $result .= '/';
        }
        if (isset($p['path']))
            $result .= $p['path'];
        if (isset($p['query'])) {
            $result .= '?' . str_replace('&', '&amp;', $p['query']);
        }
        if (isset($p['fragment']))
            $result .= '#' . $p['fragment'];
        return $result;
    }

    /**
     * Searches $content for tags and returns information about each found tag.
     *
     * Created to support button replacing process, e.g. wrapping submit/reset
     * inputs and buttons with artisteer style.
     *
     * When all the $name tags are found, they are processed by the $filter specified.
     * Filter is applied to the attributes. When an attribute contains several values
     * (e.g. class attribute), only tags that contain all the values from filter
     * will be selected. E.g. filtering by the button class will select elements
     * with class="button" and class="button validate".
     *
     * Parsing does not support nested tags. Looking for span tags in
     * <span>1<span>2</span>3</span> will return <span>1<span>2</span> and
     * <span>2</span>.
     *
     * Examples:
     *  Select all tags with class='readon':
     *   funcFindTags($html, array('*' => array('class' => 'readon')))
     *  Select inputs with type='submit' and class='button':
     *   funcFindTags($html, array('input' => array('type' => 'submit', 'class' => 'button')))
     *  Select inputs with type='submit' and class='button validate':
     *   funcFindTags($html, array('input' => array('type' => 'submit', 'class' => array('button', 'validate'))))
     *  Select inputs with class != 'bd-button'
     *   funcFindTags($html, array('input' => array('class' => '!bd-button')))
     *  Select inputs with non-empty class
     *   funcFindTags($html, array('input' => array('class' => '!')))
     *  Select inputs with class != 'bd-button' and non-empty class:
     *   funcFindTags($html, array('input' => array('class' => array('!bd-button', '!'))))
     *  Select inputs with class = button but != 'bd-button'
     *   funcFindTags($html, array('input' => array('class' => array('button', '!bd-button'))))
     *
     * @@return array of text fragments and tag information: position, length,
     *         name, attributes, raw_open_tag, body.
     */
    function funcFindTags($content, $filters)
    {
        $result = array('');
        $index = 0;
        $position = 0;
        $name = implode('|', array_keys($filters));
        $name = str_replace('*', '\w+', $name);
        // search for open tag
        if (preg_match_all(
            '~<(' . $name . ')\b(?:\s+[^\s]+\s*=\s*(?:"[^"]+"|\'[^\']+\'|[^\s>]+))*\s*/?' . '>~i', $content,
            $tagMatches, PREG_OFFSET_CAPTURE | PREG_SET_ORDER))
        {
            foreach ($tagMatches as $tagMatch) {
                $rawMatch = $tagMatch[0][0];
                $name = $tagMatch[1][0];
                $normalName = strtolower($name);
                $tag = array('name' => $name, 'position' => $tagMatch[0][1]);
                $openTagTail = (strlen($rawMatch) > 1 && '/' == $rawMatch[strlen($rawMatch) - 2])
                    ? '/>' : '>';
                // different instructions for paired and unpaired tags
                switch ($normalName)
                {
                    case 'input':
                    case 'img':
                    case 'br':
                        $tag['paired'] = false;
                        $tag['length'] = strlen($tagMatch[0][0]);
                        $tag['body'] = null;
                        $tag['close'] = 2 == strlen($openTagTail);
                        break;
                    default:
                        $closeTag = '</' . $name . '>';
                        $closeTagLength = strlen($closeTag);
                        $tag['paired'] = true;
                        $end = strpos($content, $closeTag, $tag['position']);
                        if (false === $end)
                            continue;
                        $openTagLength = strlen($tagMatch[0][0]);
                        $tag['body'] = substr($content, $tag['position'] + $openTagLength,
                            $end - $openTagLength - $tag['position']);
                        $tag['length'] = $end + $closeTagLength - $tag['position'];
                        break;
                }
                // parse attributes
                $rawAttributes = trim(substr($tagMatch[0][0], strlen($name) + 1,
                    strlen($tagMatch[0][0]) - strlen($name) - 1 - strlen($openTagTail)));
                $attributes = array();
                if (preg_match_all('~([^=\s]+)\s*=\s*(?:(")([^"]+)"|(\')([^\']+)\'|([^\s]+))~',
                    $rawAttributes, $attributeMatches, PREG_SET_ORDER))
                {
                    foreach ($attributeMatches as $attrMatch) {
                        $attrName = $attrMatch[1];
                        $attrDelimeter = (isset($attrMatch[2]) && '' !== $attrMatch[2])
                            ? $attrMatch[2]
                            : ((isset($attrMatch[4]) && '' !== $attrMatch[4])
                                ? $attrMatch[4] : '');
                        $attrValue = (isset($attrMatch[3]) && '' !== $attrMatch[3])
                            ? $attrMatch[3]
                            : ((isset($attrMatch[5]) && '' !== $attrMatch[5])
                                ? $attrMatch[5] : $attrMatch[6]);
                        if ('class' == $attrName)
                            $attrValue = explode(' ', preg_replace('~\s+~', ' ', $attrValue));
                        $attributes[$attrName] = array('delimeter' => $attrDelimeter,
                            'value' => $attrValue);
                    }
                }
                // apply filter to attributes
                $passed = true;
                $filter = isset($filters[$normalName])
                    ? $filters[$normalName]
                    : (isset($filters['*']) ? $filters['*'] : array());
                foreach ($filter as $key => $value) {
                    $criteria = is_array($value) ? $value : array($value);
                    for ($c = 0; $c < count($criteria) && $passed; $c++) {
                        $crit = $criteria[$c];
                        if ('' == $crit) {
                            // attribute should be empty
                            if ('class' == $key) {
                                if (isset($attributes[$key]) && count($attributes[$key]['value']) != 0) {
                                    $passed = false;
                                    break;
                                }
                            } else {
                                if (isset($attributes[$key]) && strlen($attributes[$key]['value']) != 0) {
                                    $passed = false;
                                    break;
                                }
                            }
                        } else if ('!' == $crit) {
                            // attribute should be not set or empty
                            if ('class' == $key) {
                                if (!isset($attributes[$key]) || count($attributes[$key]['value']) == 0) {
                                    $passed = false;
                                    break;
                                }
                            } else {
                                if (!isset($attributes[$key]) || strlen($attributes[$key]['value']) == 0) {
                                    $passed = false;
                                    break;
                                }
                            }
                        } else if ('!' == $crit[0]) {
                            // * attribute should not contain value
                            // * if attribute is empty, it does not contain value
                            if ('class' == $key) {
                                if (isset($attributes[$key]) && count($attributes[$key]['value']) != 0
                                    && in_array(substr($crit, 1), $attributes[$key]['value']))
                                {
                                    $passed = false;
                                    break;
                                }
                            } else {
                                if (isset($attributes[$key]) && strlen($attributes[$key]['value']) != 0
                                    && $crit == $attributes[$key]['value'])
                                {
                                    $passed = false;
                                    break;
                                }
                            }
                        } else {
                            // * attribute should contain value
                            // * if attribute is empty, it does not contain value
                            if ('class' == $key) {
                                if (!isset($attributes[$key]) || count($attributes[$key]['value']) == 0) {
                                    $passed = false;
                                    break;
                                }
                                if (!in_array($crit, $attributes[$key]['value'])) {
                                    $passed = false;
                                    break;
                                }
                            } else {
                                if (!isset($attributes[$key]) || strlen($attributes[$key]['value']) == 0) {
                                    $passed = false;
                                    break;
                                }
                                if ($crit != $attributes[$key]['value']) {
                                    $passed = false;
                                    break;
                                }
                            }
                        }
                    }
                    if (!$passed)
                        break;
                }
                if (!$passed)
                    continue;
                // finalize tag info constrution
                $tag['attributes'] = $attributes;
                $result[$index] = substr($content, $position, $tag['position'] - $position);
                $position = $tag['position'] + $tag['length'];
                $index++;
                $result[$index] = $tag;
                $index++;
            }
        }
        $result[$index] = $position < strlen($content) ? substr($content, $position) : '';
        return $result;
    }

    /**
     * Converts tag info created by funcFindTags back to text tag.
     *
     * @@return string
     */
    function funcTagInfoToString($info)
    {
        $result = '<' . $info['name'];
        if (isset($info['attributes']) && 0 != count($info['attributes'])) {
            $attributes = '';
            foreach ($info['attributes'] as $key => $value)
                $attributes .= ' ' . $key . '=' . $value['delimeter']
                    . (is_array($value['value']) ? implode(' ', $value['value']) : $value['value'])
                    . $value['delimeter'];
            $result .= $attributes;
        }
        if ($info['paired']) {
            $result .= '>';
            $result .= $info['body'];
            $result .= '</' . $info['name'] . '>';
        } else
            $result .= ($info['close'] ? ' /' : '') . '>';
        return $result;
    }

    /**
     * Decorates the specified tag with artisteer button style.
     *
     * @@param string $name tag name that should be decorated
     * @@param array $filter select $name tags with attributes matching $filter
     * @@return $content with replaced $name tags
     */
    function funcReplaceButtons($content, $filter = array('input' => array('class' => 'button')))
    {
        $result = '';
        foreach (funcFindTags($content, $filter) as $tag) {
            if (is_string($tag))
                $result .= $tag;
            else {
                $tag['attributes']['class']['value'][] = 'bd-button';
                $result .= funcTagInfoToString($tag);
            }
        }
        return $result;
    }

    function funcLinkButton($data = array())
    {
        return '<a class="' . (isset($data['classes']) && isset($data['classes']['a']) ? $data['classes']['a'] . ' ' : '')
            . 'bd-button" href="' . $data['link'] . '">' . $data['content'] . '</a>';
    }

    function funcHtmlFixFormAction($content)
    {
        if (preg_match('~ action="([^"]+)" ~', $content, $matches, PREG_OFFSET_CAPTURE)) {
            $content = substr($content, 0, $matches[0][1])
                . ' action="' . funcUrlToHref($matches[1][0]) . '" '
                . substr($content, $matches[0][1] + strlen($matches[0][0]));
        }
        return $content;
    }

    function funcTagBuilder($tag, $attributes = array(), $content = '') {
        $result = '<' . $tag;
        foreach ($attributes as $name => $value) {
            if (is_string($value)) {
                if (!empty($value))
                    $result .= ' ' . $name . '="' . $value . '"';
            } else if (is_array($value)) {
                $values = array_filter($value);
                if (count($values))
                    $result .= ' ' . $name . '="' . implode(' ', $value) . '"';
            }
        }
        $result .= '>' . $content . '</' . $tag . '>';
        return $result;
    }

    $funcFragments = array();

    function funcFragmentBegin($head = '')
    {
        global $funcFragments;
        $funcFragments[] = array('head' => $head, 'content' => '', 'tail' => '');
    }

    function funcFragmentContent($content = '')
    {
        global $funcFragments;
        $funcFragments[count($funcFragments) - 1]['content'] = $content;
    }

    function funcFragmentEnd($tail = '', $separator = '', $return = false)
    {
        global $funcFragments;
        $fragment = array_pop($funcFragments);
        $fragment['tail'] = $tail;
        $content = trim($fragment['content']);
        if (count($funcFragments) == 0) {
            if ($return)
                return (trim($content) == '') ? '' : ($fragment['head'] . $content . $fragment['tail']);
            echo (trim($content) == '') ? '' : ($fragment['head'] . $content . $fragment['tail']);
        } else {
            $result = (trim($content) == '') ? '' : ($fragment['head'] . $content . $fragment['tail']);
            $fragment =& $funcFragments[count($funcFragments) - 1];
            $fragment['content'] .= (trim($fragment['content']) == '' ? '' : $separator) . $result;
        }
    }

    function funcFragment($head = '', $content = '', $tail = '', $separator = '', $return = false)
    {
        global $funcFragments;
        if ($head != '' && $content == '' && $tail == '' && $separator == '') {
            $content = $head;
            $head = '';
        } elseif ($head != '' && $content != '' && $tail == '' && $separator == '') {
            $separator = $content;
            $content = $head;
            $head = '';
        }
        funcFragmentBegin($head);
        funcFragmentContent($content);
        funcFragmentEnd($tail, $separator, $return);
    }

    function funcPostprocessBlockContent($content)
    {
        return funcPostprocessContent($content);
    }

    function funcPostprocessPostContent($content)
    {
        return funcPostprocessContent($content);
    }

    function funcPostprocessContent($content)
    {
        $config = JFactory::getConfig();
        $sef = method_exists($config, 'getValue') ? $config->getValue('config.sef') : $sef = $config->get('config.sef');
        if ($sef)
            $content = str_replace('url(\'images/', 'url(\'' . JURI::base(true) . '/images/', $content);
        $content = funcReplaceButtons($content, array('input' => array('class' => array('button', '!bd-button')),
            'button' => array('class' => array('button', '!bd-button'))));
        return $content;
    }

    function funcBalanceTags($text) {

        $singleTags = array('area', 'base', 'basefont', 'br', 'col', 'command', 'embed', 'frame', 'hr', 'img', 'input', 'isindex', 'link', 'meta', 'param', 'source');
        $nestedTags = array('blockquote', 'div', 'object', 'q', 'span');

        $stack = array();
        $size = 0;
        $queue = '';
        $output = '';

        while (preg_match("/<(\/?[\w:]*)\s*([^>]*)>/", $text, $match)) {
            $output .= $queue;

            $i = strpos($text, $match[0]);
            $l = strlen($match[0]);

            $queue = '';

            if (isset($match[1][0]) && '/' == $match[1][0]) {
                // processing of the end tag
                $tag = strtolower(substr($match[1],1));

                if($size <= 0) {
                    $tag = '';
                } else if ($stack[$size - 1] == $tag) {
                    $tag = '</' . $tag . '>';
                    array_pop($stack);
                    $size--;
                } else {
                    for ($j = $size-1; $j >= 0; $j--) {
                        if ($stack[$j] == $tag) {
                            for ($k = $size-1; $k >= $j; $k--) {
                                $queue .= '</' . array_pop($stack) . '>';
                                $size--;
                            }
                            break;
                        }
                    }
                    $tag = '';
                }
            } else {
                // processing of the begin tag
                $tag = strtolower($match[1]);

                if (substr($match[2], -1) == '/') {
                    if (!in_array($tag, $singleTags))
                        $match[2] = trim(substr($match[2], 0, -1)) . "></$tag";
                } elseif (in_array($tag, $singleTags)) {
                    $match[2] .= '/';
                } else {
                    if ($size > 0 && !in_array($tag, $nestedTags) && $stack[$size - 1] == $tag) {
                        $queue = '</' . array_pop($stack) . '>';
                        $size--;
                    }
                    $size = array_push($stack, $tag);
                }

                // attributes
                $attributes = $match[2];
                if(!empty($attributes) && $attributes[0] != '>')
                    $attributes = ' ' . $attributes;

                $tag = '<' . $tag . $attributes . '>';

                if (!empty($queue)) {
                    $queue .= $tag;
                    $tag = '';
                }
            }
            $output .= substr($text, 0, $i) . $tag;
            $text = substr($text, $i + $l);
        }

        $output .= ($queue . $text);

        while($t = array_pop($stack))
            $output .= '</' . $t . '>';

        return $output;
    }

    /**
     * Build tabs
     *
     * Example:
     *   echo funcBuildTabs(array(
     *       array('id' => 'tab1', 'caption' => 'Tab 1', 'content' => ...),
     *       array('id' => 'tab2', 'caption' => 'Tab 2', 'content' => ...)
     *   ));
     */
    function funcBuildTabs($tabs) {
        $tabControl = '<div class="bd-tabcontrol">';
        $tabControlTabs = '<ul class="bd-tabcontrol-tabs">';
        $tabControlContents = '<div class="bd-tabcontrol-tab-content">';

        for($i = 0; $i < count($tabs); $i++) {
            $activeClass = (0 === $i ? 'active' : '');
            $liElement = '<li class="' . $activeClass . '"';
            $liElement .= '>';
            $aElement = '<a href="#' . $tabs[$i]['id'] . '">';
            $aElement .= $tabs[$i]['caption'] . '</a>';
            $liElement .= $aElement . '</li>';

            $contentElement = '<div ';
            $contentElement .= 'class="bd-tabcontrol-tab-pane ' . $activeClass . '" ';
            $contentElement .= 'id="' . $tabs[$i]['id'] . '">';
            $contentElement .= $tabs[$i]['content'] . '</div>';

            $tabControlTabs .= $liElement;
            $tabControlContents .= $contentElement;
        }

        $tabControlTabs .= '</ul>';
        $tabControlContents .= '</div>';

        $tabControl .= $tabControlTabs;
        $tabControl .= $tabControlContents;
        $tabControl .= '</div>';

        return $tabControl;
    }

    function funcBuildRoute($address, $attributeName = '') {

        $exts_media = array('gif', 'jpg', 'jpeg', 'png', 'wbmp', 'bmp');

        if (is_array($address)){
            $attributeName = $address[1];
            $route = $address[2];
        } else {
            $route = $address;
        }
        
        $template = JFactory::getApplication('site')->getTemplate();
        $exists_is_preview = false !== strpos($route, 'is_preview=on');

        $route_parts = pathinfo($route);
        $is_media = isset($route_parts['extension']) && in_array($route_parts['extension'], $exts_media);
        $isJs = 0 !== preg_match('/^javascript:/', $route_parts['basename']);
        $firstSymbol = substr($route, 0, 1);

        if ('#' !== $firstSymbol && !$is_media && !$exists_is_preview && !$isJs) {
            if ('on' === JRequest::getCmd('is_preview')){
                if ('/' === $firstSymbol && '' !== $template) {
                    $config = JFactory::getConfig();
                    $sef = method_exists($config, 'getValue') ? $config->getValue('config.sef') : $sef = $config->get('config.sef');
                    if ($sef) {
                        $route .= '?template=' . $template . '&is_preview=on';
                    } else {
                        $parts = explode('index.php', $route);
                        if (count($parts) > 1) {
                            $query = array_pop($parts);
                            $route = $parts[0] . 'index.php' . ($query ? $query . '&' : '?') . 'template=' . $template . '&is_preview=on';
                        }
                    }
                } else {
                    if ('' !== $template)
                        $route = '?template=' . $template . '&is_preview=on';
                }
            }
        }
        return $attributeName ? $attributeName . '="' . $route . '"' : $route;
    }

    function funcContentRoutesCorrector($content) {
        return preg_replace_callback('/(\shref)=\"?([^"]*)\"/', "funcBuildRoute", $content);
    }

    function funcPriceWrapper($price) {
        if (false !== strpos($price, 'style="display : none;"')) {
            return '';
        }

        $result = $price;
        $result = preg_replace('~<span[^>]*>([^<]*)</span>~', '$1', $result);
        $result = preg_replace('~<div[^>]*>([^<]*)</div>~', '$1', $result);

        return $result;
    }

    function addClassToTag($tagHtml, $value) {
        return preg_replace("/(class=)\"(.*?)\"/", "\\1\"\\2 ". $value ."\"", $tagHtml);
    }
    
    function renderSpecificBlog($funcName, $proxy)
    {
        $content = $proxy['content'];
        $items = $proxy['items'];
        $itemsKeys = array();
        $itemsContents = array();
        foreach($items as $key => $item) {
            $itemsKeys[] = $key;
            $itemsContents[] = call_user_func($funcName, $item['params']);
        }
        return str_replace($itemsKeys, $itemsContents, $content);
    }
    
    function renderSpecificPagination($funcName, $list) 
    {
        return call_user_func($funcName, $list);
    }

    function id_attribute($id) {
        if ($GLOBALS['designer_settings']['is_preview'])
            return 'data-control-id="' . $id . '"';
        return '';
    }
}